From 8729da81aef380e0cac6bba0eb8ea4712bbde9bc Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 28 2020 06:34:12 +0000
Subject: [PATCH 1836/2232] Clean up guards from C++ standard library type shims


These shims are only emitted into the cc file, not any headers, so there
is no way they would end up more than once in the compiled code.

---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index ab463ea..981628c 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -1562,14 +1562,7 @@ fn write_rust_vec_impl(out: &mut OutFile, element: &RustName) {
 
 fn write_unique_ptr(out: &mut OutFile, ident: &RustName) {
     let ty = UniquePtr::Ident(ident);
-    let instance = ty.to_mangled(out.types);
-
-    writeln!(out, "#ifndef CXXBRIDGE1_UNIQUE_PTR_{}", instance);
-    writeln!(out, "#define CXXBRIDGE1_UNIQUE_PTR_{}", instance);
-
     write_unique_ptr_common(out, ty);
-
-    writeln!(out, "#endif // CXXBRIDGE1_UNIQUE_PTR_{}", instance);
 }
 
 // Shared by UniquePtr<T> and UniquePtr<CxxVector<T>>.
@@ -1689,8 +1682,6 @@ fn write_shared_ptr(out: &mut OutFile, ident: &RustName) {
     let inner = resolved.to_fully_qualified();
     let instance = ident.to_symbol(out.types);
 
-    writeln!(out, "#ifndef CXXBRIDGE1_SHARED_PTR_{}", instance);
-    writeln!(out, "#define CXXBRIDGE1_SHARED_PTR_{}", instance);
     out.include.new = true;
     out.include.utility = true;
 
@@ -1756,8 +1747,6 @@ fn write_shared_ptr(out: &mut OutFile, ident: &RustName) {
     );
     writeln!(out, "  self->~shared_ptr();");
     writeln!(out, "}}");
-
-    writeln!(out, "#endif // CXXBRIDGE1_SHARED_PTR_{}", instance);
 }
 
 fn write_cxx_vector(out: &mut OutFile, element: &RustName) {
@@ -1766,8 +1755,6 @@ fn write_cxx_vector(out: &mut OutFile, element: &RustName) {
 
     out.include.cstddef = true;
 
-    writeln!(out, "#ifndef CXXBRIDGE1_VECTOR_{}", instance);
-    writeln!(out, "#define CXXBRIDGE1_VECTOR_{}", instance);
     writeln!(
         out,
         "::std::size_t cxxbridge1$std$vector${}$size(const ::std::vector<{}> &s) noexcept {{",
@@ -1785,6 +1772,4 @@ fn write_cxx_vector(out: &mut OutFile, element: &RustName) {
 
     out.include.memory = true;
     write_unique_ptr_common(out, UniquePtr::CxxVector(element));
-
-    writeln!(out, "#endif // CXXBRIDGE1_VECTOR_{}", instance);
 }

